/*TIMOTHY GOGGIN, 
PROGRAM TYPE: FACTORING, QUADRATIC & COMPLEX NUMBERS, 
74667.3610@compuserve.com for questions or comments,
FREE CODE*/

#include <stdio.h>
#include <math.h>

#define FALSE 0
#define TRUE 1
#define sqr(x) ((x)*(x))
#define SIGN -1
#define MAX	30

void FactorPolynomials();
void Quadratic();
void Quadratic_Equation();
void Quadratic_Root();
void Cubic_Root();
void Fourth_Root();
void Fifth_Root();
void Sixth_Root();

int ImaginaryFlag; /*boolean to indicate presence of imaginary nums*/
int a, b, c, d, A, B, C, selection;

void main()
{
	ImaginaryFlag = FALSE;

	/*The main menu*/

	printf("******************************************************************************\n\n");

	printf("**\t\t  FACTORING, QUADRATIC, AND COMPLEX NUMBERS: THE PROGRAM   **\n\n");
	printf("**\t\t        CHOOSE FROM ONE OF THE FOLLOWING OPTIONS           **\n\n");

	printf("**\t\t              1. FACTORING POLYNOMIALS                     **\n\n");

	printf("**\t\t2. DISCOVER THE CUBIC (OR GREATER) EQUATION FROM YOUR INPUT**\n\n");

	printf("******************************************************************************\n\n");

	printf("Enter Selection:");
	scanf ("%d", &selection);

	switch (selection) {
		case 1:
			printf ("You have chosen to Factor Polynomials\n\n");
			FactorPolynomials();
			break;
	/*This takes you into the Factoring Polynomials*/

		case 2:
			printf ("You have chosen to give me the roots & I will give an equation\n\n");
			Quadratic_Equation();
			break;
	/*This creates a cubic or greater equation*/
		}

}

void FactorPolynomials()
{
	int A1[MAX], A2[MAX], C1[MAX], C2[MAX], AC1[MAX], AC2[MAX]; /*arrays to store factors of A & C*/
	int z; /*for-loop counter*/
	int Flag; /*a flag to see if polynomial needs the quadratic or not*/

		printf("******************************************************************************\n\n");

		printf ("\t\t POLYNOMIAL = Ax^2 + Bx + C.\n");

		printf ("\t\t ENTER A:");
		scanf ("%d", &A);
		printf ("\n\t\t ENTER B:");
		scanf ("%d", &B);
		printf ("\n\t\t ENTER C:");
		scanf ("%d", &C);
		/*basic stuff*/
		printf("******************************************************************************\n\n");

		A1[0] = A;
		A2[0] = 1;

		C1[0] = C;
		C2[0] = 1;

		/*tests if A is negative or larger than 1; if A is negative, the negative number
		must be removed, then (in both cases) factored by numbers that divide evenly into it*/

		/*NOTE: IF THE FOLLOWING TESTS FAIL, THE PROGRAM CALLS THE QUADRATIC FUNCTION,
		Quadratic()*/

		if (A <0)
		{
			int x;
			int j;
			j = 1;

			/*if A is negative the equation must be multiplied by -1 to get
			rid of the -1*/

			A = SIGN*A;
			B = SIGN*B;
			C = SIGN*C;

			printf("A was negative...\n\nhad to multiply the equation by -1 to change values appropriately\n\n");
			printf("The equation is now %dx^2 + %dx + %d\n\n", A, B, C);

			/*my plan is to store all the possible factors of A in two integer arrays,
			A1, A2: this includes A itself and 1, which is at position 0 in A1 & A2*/

			for (x = 2; x < A; x++)/*I start at 2 because I've already taken 1 into account*/
			{
				do
				{
					A1[j] = A/x;
					A2[j] = A/A1[j];
					j++;
				} while ((A%x == 0)&&(A1[j] != A1[j-1])&&(A2[j] != A2[j-1])) ;
			}

		}
		else if (A >1)
		{
			int x;
			int j;
			j = 1;

			/*my plan is to store all the possible factors of A in two integer arrays,
			A1, A2: this includes A itself and 1, which is at position 0 in A1 & A2*/

			for (x = 2; x < A; x++)/*I start at 2 because I've already taken 1 into account*/
			{
				do
				{
					A1[j] = A/x;
					A2[j] = A/A1[j];
					j++;
				} while ((A%x == 0)&&(A1[j] != A1[j-1])&&(A2[j] != A2[j-1])) ;
			}

		}

		/*tests if C is negative or larger than 1; a needed test for factors*/

		if (C <0) /*if C is a negative number; it must be converted to find factors*/
		{
			int y;
			int i;
			i = 1;

			C = C*SIGN; /*changes it to a positive number*/

			/*my plan is to store all the possible factors of C in two integer arrays,
			C1, C2: this includes C itself and 1, which is at position 0 in C1 & C2*/

			for (y = 2; y < C; y++) /*I start at 2 because I've already taken 1 into account*/
			{
				do
				{
					C1[i] = (C/y);
					C2[i] = (C/C1[i]);
					i++;
				} while ((C%y == 0)&&(C1[i] != C1[i-1])&&(C2[i] != C2[i-1])) ;

			}

			C = C*SIGN; /*restores its sign*/
		}
		else if (C >1)
		{
			int y;
			int i;
			i = 1;

			/*my plan is to store all the possible factors of C in two integer arrays,
			C1, C2: this includes C itself and 1, which is at position 0 in C1 & C2*/

			for (y = 2; y < C; y++) /*I start at 2 because I've already taken 1 into account*/
			{
				do
				{
					C1[i] = C/y;
					C2[i] = C/C1[i];
					i++;
				} while ((C%y == 0)&&(C1[i] != C1[i-1])&&(C2[i] != C2[i-1])) ;

			}

		}

		for (z = 0; z < MAX; z++)
		{
			/*multiplying the first set of factors; I will test these against B's value later*/
			AC1[z] = A1[z]*C1[z];
			AC2[z] = A2[z]*C2[z];

				if (AC1[z]+AC2[z] == B)
				{
					/*captures those values that work to the 0th position*/
					AC1[0] = AC1[z];
					AC2[0] = AC2[z];
					A1[0] = A1[z];
					C1[0] = C1[z];
					A2[0] = A2[z];
					C2[0] = C2[z];
					Flag = TRUE;
					break;
				}
				else /*the equation can not be factored using this method*/
				{
					Flag = FALSE;
				}
		}

	if (Flag == FALSE)
	{
		printf("The equation can not be factored by this method...\nIt needs the quadratic formula...\nPlease wait a few moments\n\n");
		Quadratic();
	}
	else if (Flag == TRUE)
	{
		printf("The equation is equal to (%dx + %d)(%dx + %d)\n\n", A1[0], C1[0], A2[0], C2[0]);
		printf("x = %d and x = %d\n\n", (C1[0]/A1[0]), (C2[0]/A2[0]));
	}

}


void Quadratic()
{
	float fl_sample, b_sqr; /*for quadratic formula*/
	float neg_possibility, pos_possibility; /*for quadratic formula*/

	b_sqr = (sqr(B));
	fl_sample = b_sqr-(4*A*C);

	if (fl_sample < 0)
	{
		fl_sample = SIGN * fl_sample;
		ImaginaryFlag = TRUE; /*There is a complex sqrt*/
	}

	else
	{
		ImaginaryFlag = FALSE; /*There is a real sqrt*/
	}

	fl_sample = sqrt(fl_sample);/*ok to take the sqrt now.*/

	if (ImaginaryFlag == TRUE)
	{
		printf("x = %d %c %.2fi/%d", SIGN*B, 241, fl_sample, 2*A);
	}
	else
	{
		neg_possibility = (SIGN*B + fl_sample)/(2*A); /*the negative answer*/
		pos_possibility = (SIGN*B - fl_sample)/(2*A); /*the positive answer*/
		printf("x = %.4f and x = %.4f \n\n", neg_possibility, pos_possibility);
	}
}

void Quadratic_Equation()
{
	int sample_1;

	printf ("Tell me what degree the equation you want me to convert.\n");
	scanf("%d", &sample_1);
	switch (sample_1)
	{
		case 2:
		Quadratic_Root();
		break;

		case 3:
		Cubic_Root();
		break;

		case 4:
		Fourth_Root();
		break;

		case 5:
		Fifth_Root();
		break;

		case 6:
		Sixth_Root();
		break;
		}
}

void Quadratic_Root()
{
	printf("THE FACTORS WILLED BE LAYED OUT AS FOLLOWS:\n");
	printf("(ax-b)*(cx-d)\n");

	printf("Please enter a:");
	scanf("%d", &a);
	printf("\n");
	printf("Please enter b:");
	scanf("%d", &b);
	printf("\n");
	printf("Please enter c:");
	scanf("%d", &c);
	printf("\n");
	printf("Please enter d:");
	scanf("%d", &d);
	printf("\n");

	printf("%dx^2 + %dx + %dx + %d = \n", a*c, (SIGN*b*c), (SIGN*d*a), ((SIGN*b)*(SIGN*d)));
	printf("%dx^2 + %dx + %d.\n", a*c, ((SIGN*b*c)+(SIGN*d*a)), ((SIGN*b)*(SIGN*d)));
}

void Cubic_Root()
{
	int e, f;

	printf("THE FACTORS WILLED BE LAYED OUT AS FOLLOWS:\n");
	printf("(ax-b)*(cx-d)*(ex-f)\n");

	printf("Please enter a:");
	scanf("%d", &a);
	printf("\n");
	printf("Please enter b:");
	scanf("%d", &b);
	printf("\n");
	printf("Please enter c:");
	scanf("%d", &c);
	printf("\n");
	printf("Please enter d:");
	scanf("%d", &d);
	printf("\n");
	printf("Please enter e:");
	scanf("%d", &e);
	printf("\n");
	printf("Please enter f:");
	scanf("%d", &f);
	printf("\n");
	printf("%dx^3 + %dx^2 + %dx^2 + %dx^2 + %dx + %dx + %dx + %d + %d + %d =\n", a*c*e, (SIGN*b*c), (SIGN*d*e), (SIGN*f*a), ((SIGN*b)*(SIGN*d), ((SIGN*d)*(SIGN*f)), ((SIGN*f)*(SIGN*b))));
	printf("%dx^3 + %dx^2 + %dx + %d .\n", a*c*e, ((SIGN*b*c)*(SIGN*d*e)*(SIGN*f*a)), (((SIGN*b)*(SIGN*d))+ ((SIGN*d)*(SIGN*f))+((SIGN*f*SIGN*b))));
}

void Fourth_Root()
{
	int e, f, g, h, temp_a, temp_b, temp_c, temp_a1, temp_b1, temp_c1;

	printf("THE FACTORS WILLED BE LAYED OUT AS FOLLOWS:\n");
	printf("(ax-b)*(cx-d)*(ex-f)*(gx-h)\n");

	printf("Please enter a:");
	scanf("%d", &a);
	printf("\n");
	printf("Please enter b:");
	scanf("%d", &b);
	printf("\n");
	printf("Please enter c:");
	scanf("%d", &c);
	printf("\n");
	printf("Please enter d:");
	scanf("%d", &d);
	printf("\n");
	printf("Please enter e:");
	scanf("%d", &e);
	printf("\n");
	printf("Please enter f:");
	scanf("%d", &f);
	printf("\n");
	printf("Please enter g:");
	scanf("%d", &g);
	printf("\n");
	printf("Please enter h:");
	scanf("%d", &h);
	printf("\n");
	temp_a = (a*c); /*to simplify the parsing*/
	temp_b = (SIGN*b*c)+ (SIGN*d*a);
	temp_c = ((SIGN*b)*(SIGN*d));
	temp_a1 = (e*g); /*to simplify the parsing*/
	temp_b1 = (SIGN*f*g)+ (SIGN*h*e);
	temp_c1 = ((SIGN*f)*(SIGN*h));
	/*changing the values of the orig. variables to reflect the
	the new multiplication; makes it more manageable*/
	a = temp_a;
	b = temp_b;
	c = temp_c;
	d = temp_a1;
	e = temp_b1;
	f = temp_c1;
	printf("(%dx^2 + %dx + %d)*(%dx^2 + %dx + %d) =\n\n ", a, b, c, d, e, f);
	printf("%dx^4 + %dx^3 + %dx^2 + %dx + %d.\n\n ", a*d, ((b*d)+(e*a)), ((b*e)+(c*d)+(f*a)), ((c*e)+(f*b)), (c*f));
}

void Fifth_Root()
{
	int e, f, g, h, i, j, temp_a, temp_b, temp_c, temp_a1, temp_b1, temp_c1;

	printf("THE FACTORS WILLED BE LAYED OUT AS FOLLOWS:\n");
	printf("(ax-b)*(cx-d)*(ex-f)*(gx-h)*(ix-j)\n");

	printf("Please enter a:");
	scanf("%d", &a);
	printf("\n");
	printf("Please enter b:");
	scanf("%d", &b);
	printf("\n");
	printf("Please enter c:");
	scanf("%d", &c);
	printf("\n");
	printf("Please enter d:");
	scanf("%d", &d);
	printf("\n");
	printf("Please enter e:");
	scanf("%d", &e);
	printf("\n");
	printf("Please enter f:");
	scanf("%d", &f);
	printf("\n");
	printf("Please enter g:");
	scanf("%d", &g);
	printf("\n");
	printf("Please enter h:");
	scanf("%d", &h);
	printf("\n");
	printf("Please enter i:");
	scanf("%d", &i);
	printf("\n");
	printf("Please enter j:");
	scanf("%d", &j);
	printf("\n");
	temp_a = (a*c); /*to simplify the parsing*/
	temp_b = (SIGN*b*c)+ (SIGN*d*a);
	temp_c = ((SIGN*b)*(SIGN*d));
	temp_a1 = (e*g); /*to simplify the parsing*/
	temp_b1 = (SIGN*f*g)+ (SIGN*h*e);
	temp_c1 = ((SIGN*f)*(SIGN*h));
	/*changing the values of the orig. variables to reflect the
	the new multiplication; makes it more manageable*/
	a = temp_a;
	b = temp_b;
	c = temp_c;
	d = temp_a1;
	e = temp_b1;
	f = temp_c1;
	printf("(%dx^2 + %dx + %d)*(%dx^2 + %dx + %d)*(%dx + %d) =\n\n ", a, b, c, d, e, f, i, j);
	printf("(%dx^4 + %dx^3 + %dx^2 + %dx + %d) * (%dx + %d)= .\n\n ", (a*d), ((b*d)+(e*a)), ((b*e)+(c*d)+(f*a)), ((c*e)+(f*b)), (c*f), i, -j);
	temp_a = (a*d);
	temp_b = ((b*d)+(e*a));
	temp_c = ((b*e)+(c*d)+(f*a));
	temp_a1 = ((c*e)+(f*b));
	temp_b1 = (c*f);
	/*changing the values of the orig. variables to reflect the
	the new multiplication; makes it more manageable*/
	a = temp_a;
	b = temp_b;
	c = temp_c;
	d = temp_a1;
	e = temp_b1;
	/*multiplying (ax^4+bx^3+cx^2+dx+e)*(ix-j)*/
	printf("%dx^5 + %dx^4 + %dx^3 + %dx^2 + %dx + %d", a*i, ((b*i)+(a*-j)), ((c*i)+(b*-j)), ((d*i)+(c*-j)), ((e*i)+(d*-j)), (e*-j));
}

void Sixth_Root()
{
	int e, f, g, h, i, j, k, l;
	int temp_a, temp_b, temp_c, temp_a1, temp_b1, temp_c1, temp_a2, temp_b2, temp_c2;

	printf("THE FACTORS WILLED BE LAYED OUT AS FOLLOWS:\n");
	printf("(ax-b)*(cx-d)*(ex-f)*(gx-h)*(ix-j)*(kx-l)\n");

	printf("Please enter a:");
	scanf("%d", &a);
	printf("\n");
	printf("Please enter b:");
	scanf("%d", &b);
	printf("\n");
	printf("Please enter c:");
	scanf("%d", &c);
	printf("\n");
	printf("Please enter d:");
	scanf("%d", &d);
	printf("\n");
	printf("Please enter e:");
	scanf("%d", &e);
	printf("\n");
	printf("Please enter f:");
	scanf("%d", &f);
	printf("\n");
	printf("Please enter g:");
	scanf("%d", &g);
	printf("\n");
	printf("Please enter h:");
	scanf("%d", &h);
	printf("\n");
	printf("Please enter i:");
	scanf("%d", &i);
	printf("\n");
	printf("Please enter j:");
	scanf("%d", &j);
	printf("\n");
	printf("Please enter k:");
	scanf("%d", &k);
	printf("\n");
	printf("Please enter l:");
	scanf("%d", &l);
	printf("\n");
	temp_a = (a*c); /*to simplify the parsing*/
	temp_b = (SIGN*b*c)+ (SIGN*d*a);
	temp_c = ((SIGN*b)*(SIGN*d));
	temp_a1 = (e*g); /*to simplify the parsing*/
	temp_b1 = (SIGN*f*g)+ (SIGN*h*e);
	temp_c1 = ((SIGN*f)*(SIGN*h));
	temp_a2 = (i*k); /*to simplify the parsing*/
	temp_b2 = (SIGN*j*k)+ (SIGN*l*i);
	temp_c2 = ((SIGN*j)*(SIGN*l));
	/*changing the values of the orig. variables to reflect the
	the new multiplication; makes it more manageable*/
	a = temp_a;
	b = temp_b;
	c = temp_c;
	d = temp_a1;
	e = temp_b1;
	f = temp_c1;
	g = temp_a2;
	h = temp_b2;
	i = temp_c2;
	printf("(%dx^2 + %dx + %d)*(%dx^2 + %dx + %d)*(%dx^2 + %dx + %d)= \n\n ", a, b, c, d, e, f, g, h, i);
	temp_a = (a*d);
	temp_b = ((b*d)+(e*a));
	temp_c = ((b*e)+(c*d)+(f*a));
	temp_a1 = ((c*e)+(f*b));
	temp_b1 = (c*f);
	/*changing the values of the orig. variables to reflect the
	the new multiplication; makes it more manageable*/
	a = temp_a;
	b = temp_b;
	c = temp_c;
	d = temp_a1;
	e = temp_b1;
	/*multiplying (ax^4+bx^3+cx^2+dx+e)*(ix-j)*/
	printf("(%dx^4 + %dx^3 + %dx^2 + %dx + %d)*(%dx^2 + %dx + %d) = \n\n", a, b, c, d, e, g, h, i);
	printf("%dx^6 + %dx^5 + %dx^4 + %dx^3 + %dx^2 + %dx + %d\n\n", a*g, ((b*g)+(h*a)), ((c*g)+(h*b)+(i*a)), ((d*g)+(h*c)+(i*b)), ((e*g)+(h*d)+(i*c)), ((h*e)+(i*d)), (i*e));
}

